/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/




#include "Client.h"
#include "Projectile.h"
#include "Statut.h"
#include "Joueur.h"
#include "Monde.h"
#include "Menu.h"
#include "Texte.h"
#include "Jeu.h"

#define PORTTCP 23734
#define PORTUDP 23735


Client::Client(Jeu* jeu) : gpJeu(jeu)
{
}

int Client::init()
{
    int i;
    //port = 7001;	
    stopTCP = true;
    stopUDP = true;
    attendUDP = true;
    
    WSAStartup(MAKEWORD(2,0),&wsa);	

	sin.sin_family=AF_INET;
	sin.sin_addr.s_addr=inet_addr((gpJeu->getIPName()).c_str());
	sin.sin_port=htons(gpJeu->getPortTCP());
    //sin.sin_port=htons(PORTTCP);
	
	//creation socket TCP
	sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	if(connect(sock,(SOCKADDR*)&sin,sizeof(sin)))
	{
          return 1;
    }
	
	//creation socket UDP
	sockUDP = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sockUDP == INVALID_SOCKET)
    {
          return 1;
    }
    
	CliProjectile == new Projectile(gpJeu, 0, N, 0, 0, 0);
	
	tosize = sizeof to;
	to.sin_addr.s_addr=inet_addr((gpJeu->getIPName()).c_str());
	//to.sin_port = htons(PORTUDP);
	to.sin_port = htons(gpJeu->getPortUDP());
	to.sin_family = AF_INET;
	tosize = sizeof to;
	
	
    //Envoi du pseudo
    int err;
	string envoiPseudo = gpJeu->getJoueur()->getPseudo();
	std::ostringstream oss;
    string envoiInfo="";
	int tailleBuffer = 800;
	char* buffer = new char[tailleBuffer];
	
    oss.str(""); 
    oss << envoiPseudo;
    oss << "!";
    oss << gpJeu->getJoueur()->getNom();
    oss << "!";
    envoiInfo = oss.str();
	for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
	for (i = 0; i < envoiInfo.length(); i++) buffer[i] = envoiInfo[i];
	err=send(sock,buffer,envoiInfo.length(),0);
    
    //Reception des infos du serveur
    char *stptr;
	
	for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
    err=recv(sock,buffer,tailleBuffer,0);
    stptr = strtok (buffer,"!");
    gpJeu->getJoueur()->setNumero(atoi(stptr));
    stptr = strtok (NULL, "!");
    gpJeu->getPartie()->setArene(atoi(stptr));
    stptr = strtok (NULL, "!");
    gpJeu->getPartie()->setTypeJeu(atoi(stptr));
    stptr = strtok (NULL, "!");
    gpJeu->getPartie()->setLimite(atoi(stptr));
   
	return 0;
}

void Client::lanceThread()
{
    //lance le thread TCP
    HANDLE hProcessThreadTCP;
	hProcessThreadTCP = CreateThread(NULL, 0,&Client::ThreadLauncherStartTCP, this,0,NULL);
	
	//lance le thread ecoutUDP
    HANDLE hProcessThreadUDP;
	hProcessThreadUDP = CreateThread(NULL, 0,&Client::ThreadLauncherStartUDP, this,0,NULL);
	
	//lance le thread envoiUDP
    HANDLE hProcessThread2UDP;
	hProcessThread2UDP = CreateThread(NULL, 0,&Client::ThreadLauncherStart2UDP, this,0,NULL);
	
}

Client::~Client()
{
    delete  CliProjectile;              
}

DWORD Client::DialogueTCP()
{
    int err=0;
	int i;
	string envoiInfo = "";
	std::ostringstream out;
    int ret=0;
	char *stptr;
	Projectile* tmpProjectile;
	
    int lire = 0;
    int totalRecu;


    int tailleBufferTCP = 800;
	char* bufferTCP = new char[tailleBufferTCP];
	char** infoRecuTCP = new char*[100];
	
	//a chaque tour on vois qui est present (permet de savoir qui s'en va
    int* joueurPresent = new int[gpJeu->getPartie()->getNbJoueur()];
    stopTCP = false;
    
    while(!stopTCP)
    {
                    
        //Information  envoyer
        out.str("");
        out << gpJeu->getJoueur()->getNumero();
        out << "!";
        out << gpJeu->getJoueur()->getCouleur();
        out << "!";
        out << gpJeu->getJoueur()->getNom();
        out << "!";
        
        //vie
        out << gpJeu->getJoueur()->viensDeRevivre;
        out << "!";
        
        
        //zone
        out << gpJeu->getZone();
        out << "!";
        
        //objet
        if(gpJeu->getJoueur()->getObjet() < 5)
            out << gpJeu->getJoueur()->getObjet();
        else
        {    
            //5vide;6rouge;7vert;8bleu
            out << (gpJeu->getJoueur()->getObjet()+gpJeu->getJoueur()->hasBouteille(0)-1);
        }    
        out << "!";
        
        
        envoiInfo = out.str();
        
        //cout<<"ClientETCP:"<<envoiInfo<<endl;
	    
        
        //ENVOI
        for (i = 0; i < tailleBufferTCP; i++) bufferTCP[i] = ' ';
    	for (i = 0; i < envoiInfo.length (); i++) bufferTCP[i] = envoiInfo[i];
    	err=send(sock,bufferTCP,envoiInfo.length(),0);
    	
        //RECEPTION
        for (i = 0; i < tailleBufferTCP; i++) bufferTCP[i] = ' ';
        err=recv(sock,bufferTCP,tailleBufferTCP,0);
    	    
        std::istringstream issBuf(bufferTCP);
        //cout<<"ClientRTCP:"<<issBuf.str()<<endl;
            
        stptr = strtok (bufferTCP,"!");
        lire = 0; 
        while (stptr != NULL)
        {
            infoRecuTCP[lire]=stptr;
            lire++;
            stptr = strtok (NULL, "!");
        }
        
        delete stptr;
        
        totalRecu = lire;
        lire = 2; // saute les infos Nbjoueur et parti fini
        
        //info Perso
        //revie
        if(atoi(infoRecuTCP[lire]) > 0 && gpJeu->getJoueur()->viensDeRevivre == 1)
          { 
             gpJeu->getJoueur()->viensDeRevivre = 0; //le seveur a compris que le joueur revie
          }
        
        if(gpJeu->getJoueur()->getVie() > atoi(infoRecuTCP[lire]) && gpJeu->getJoueur()->viensDeRevivre == 0)
        {
           gpJeu->getJoueur()->setVie(atoi(infoRecuTCP[lire]));
           if(gpJeu->getJoueur()->getTypeAnim() != CHUTE && gpJeu->getJoueur()->getTypeAnim() != MORT) gpJeu->getJoueur()->setTypeAnim(TOUCHE); //Youhou avoir si vir 
        }
        
        //boit
        if(gpJeu->getJoueur()->getVie() < atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setVie(atoi(infoRecuTCP[lire]));        
        }
        lire++;
        
        //recoit le score
        if(gpJeu->getJoueur()->getScore() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setScore(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        //recoit son numero
        if(gpJeu->getJoueur()->getNumero() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setNumero(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        //recoit sa magie
        if(gpJeu->getJoueur()->getMagie() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setMagie(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        //recoit ses fleches
        if(gpJeu->getJoueur()->getFleche() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setFleche(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        //recoit ses rubis
        if(gpJeu->getJoueur()->getRubis() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setRubis(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        //recoit son statue de fantome
        if(gpJeu->getJoueur()->isFantome() != atoi(infoRecuTCP[lire]))
        {
           gpJeu->getJoueur()->setFantome(atoi(infoRecuTCP[lire]));
        }
        lire++;
        
        int numeroJoueurLu = 0;
        
        //on suppose que tous le monde est absent          
        for(i=0; i< gpJeu->getPartie()->getNbJoueur(); i++) joueurPresent[i]=1;  
        joueurPresent[gpJeu->getJoueur()->getNumero()]=0; //deja soit mme on est present
        
        //autres joueures (le -1 c'est car le serveur nous envoi pas nos info ici)
        for(i=0; i<atoi(infoRecuTCP[0])-1; i++)
        {
            numeroJoueurLu = atoi(infoRecuTCP[lire]);
            lire++;
        	 
            if(gpJeu->getAutreJoueur(numeroJoueurLu)->estInvisible())
                gpJeu->getAutreJoueur(numeroJoueurLu)->visible();
                 
            if(gpJeu->getAutreJoueur(numeroJoueurLu)->getCouleur()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setCouleur(atoi(infoRecuTCP[lire]));
        	lire++;
        	
            if(gpJeu->getAutreJoueur(numeroJoueurLu)->getNom()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setNom(atoi(infoRecuTCP[lire]));
        	lire++;
        	
        	if(gpJeu->getAutreJoueur(numeroJoueurLu)->getPseudo()!=infoRecuTCP[lire])
                gpJeu->getAutreJoueur(numeroJoueurLu)->setPseudo(infoRecuTCP[lire]);
        	lire++;
        	
        	if(gpJeu->getAutreJoueur(numeroJoueurLu)->getZone()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setZone(atoi(infoRecuTCP[lire]));
            lire++;
        	
        	if(gpJeu->getAutreJoueur(numeroJoueurLu)->getScore()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setScore(atoi(infoRecuTCP[lire]));
            lire++;
        	
        	if(gpJeu->getAutreJoueur(numeroJoueurLu)->getObjet()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setObjet(atoi(infoRecuTCP[lire]));
            lire++;
            
            if(gpJeu->getAutreJoueur(numeroJoueurLu)->isFantome()!=atoi(infoRecuTCP[lire]))
                gpJeu->getAutreJoueur(numeroJoueurLu)->setFantome(atoi(infoRecuTCP[lire]));
            lire++;
        	
        	joueurPresent[numeroJoueurLu]=0; //bon ben lui il est la
        }
        
        for(i=0; i< gpJeu->getPartie()->getNbJoueur(); i++)
            if(joueurPresent[i]==1 && !gpJeu->getAutreJoueur(i)->estInvisible()) // si le joueur etait plus la
               gpJeu->getAutreJoueur(i)->nonVisible(); // on le cache
        
        for(i=0; i<3;i++) //d'ou le TroisMsg dans listServeur
        {
            //cout<<" recu "<< infoRecuTCP[lire]<<"-" <<infoRecuTCP[lire+1] <<"-"<<infoRecuTCP[lire+2] ;
            if(atoi(infoRecuTCP[lire]) != 0)
                gpJeu->setMessage(atoi(infoRecuTCP[lire]),atoi(infoRecuTCP[lire+1]),atoi(infoRecuTCP[lire+2]));
        
            lire +=3;
        }
 
        
        attendUDP = false;
        
        if (atoi(infoRecuTCP[1]) == 1)
        {
           gpJeu->finDePartie();
           stopTCP = true;
           stopUDP = true;
           closesocket(sock);
           closesocket(sockUDP);
           err=send(sock,"Q",1,0);   	
        }
        else
        {
           Sleep(20);
        }
     }
    
}

DWORD Client::EcouteUDP()
{
    int i;
    
    int ret=0;
    int err=0;
    int threadtailleBuffer = 1000;
	char * threadbuffer = new char[threadtailleBuffer];
	char ** threadinfoRecu = new char*[100];
	
    for (i = 0; i < threadtailleBuffer; i++) threadbuffer[i] = ' ';
    
    FD_ZERO(&readfs);
    FD_SET(sockUDP, &readfs);
    
    while(attendUDP) {Sleep(20);}
    
    stopUDP=false;
    
    while(!stopUDP)
    {
       FD_ZERO(&readfs);
       FD_SET(sockUDP, &readfs);
       
           
       if((ret = select(sockUDP + 1, &readfs, NULL, NULL, NULL)) == -1)
       {
          gpJeu->setMessage(1);
       }
    
       if(FD_ISSET(sockUDP, &readfs))
       {
            err=recvfrom(sockUDP,threadbuffer,threadtailleBuffer,0,(SOCKADDR *) &to, &tosize);
            
            std::istringstream issBuf(threadbuffer);
            
        	char *stptr;
        	Projectile* tmpProjectile;
        	
            int lire = 0;
            int totalRecu;
        	
        	
            stptr = strtok (threadbuffer,"!");
             
            while (stptr != NULL)
            {
                threadinfoRecu[lire]=stptr;
                lire++;
                stptr = strtok (NULL, "!");
            }
            
            totalRecu = lire;
            lire = 1;
            int numeroJoueurLu = 0;
            
            //autres joueures
            for(i=0; i<=atoi(threadinfoRecu[0]);i++)
            {
                numeroJoueurLu = atoi(threadinfoRecu[lire]);
                lire++;
            	
            	if(numeroJoueurLu != gpJeu->getJoueur()->getNumero())
                {                 
                    gpJeu->getAutreJoueur(numeroJoueurLu)->setX(atoi(threadinfoRecu[lire]));
                    lire++;
                	
                    gpJeu->getAutreJoueur(numeroJoueurLu)->setY(atoi(threadinfoRecu[lire]));
                	lire++;
                	
                    gpJeu->getAutreJoueur(numeroJoueurLu)->setDirection(gpJeu->int2Dir(atoi(threadinfoRecu[lire])));
                	lire++;
                		
                    if(gpJeu->getAutreJoueur(numeroJoueurLu)->getTypeAnim()!=atoi(threadinfoRecu[lire]))
                    {
                        gpJeu->getAutreJoueur(numeroJoueurLu)->setTypeAnim(atoi(threadinfoRecu[lire]));
                    }
                    lire++;
                 }
                 else
                   lire+=4;
            }
            
            CliProjectile = new Projectile(gpJeu, 0, N, 0, 0, 0);
            
            int nbPro = atoi(threadinfoRecu[lire]);
            //gpJeu->setMessage("aa"+gpJeu->fct.int2string(nbPro)+"zz"+gpJeu->fct.int2string(lire));
            
            lire++;
            for(i=0; i<nbPro;i++)
            {
               tmpProjectile = new Projectile(gpJeu, atoi(threadinfoRecu[lire]), gpJeu->int2Dir(atoi(threadinfoRecu[lire+1])), atoi(threadinfoRecu[lire+2]), atoi(threadinfoRecu[lire+3]), 0);
               tmpProjectile->setAnim(atoi(threadinfoRecu[lire+4]));
               CliProjectile->ajout(tmpProjectile);
               lire+=5;
            }
            
        }
    }
    
}

//void Client::EnvoiUDP() 
DWORD Client::EnvoiUDP()
{
    //memset(buffer,0,sizeof(buffer));
	int err=0;
	int i;
	string envoiInfo = "";
	int threadtailleBuffer = 800;
	char * threadbuffer = new char[threadtailleBuffer];
	    
    std::ostringstream out;
    //Position
    while(stopUDP) {Sleep(20);}
    
    while(!stopUDP)
    {
        out.str("");
        out << gpJeu->getJoueur()->getNumero();
        out << "!";
        out << gpJeu->getJoueur()->getX();
        out << "!";
        out << gpJeu->getJoueur()->getY();
        out << "!";
        out << gpJeu->dir2Int(gpJeu->getJoueur()->getDirection());
        out << "!";
        
        //animation
        out << gpJeu->getJoueur()->getTypeAnim();
        out << "!";
        
        envoiInfo = out.str();
        
        //scanf("%s",buffer);
        for (i = 0; i < threadtailleBuffer; i++) threadbuffer[i] = ' ';
    	for (i = 0; i < envoiInfo.length (); i++) threadbuffer[i] = envoiInfo[i];
   	    
   	    //cout<<"ClientE:"<<envoiInfo<<endl;
	    
   	    
        err=sendto(sockUDP,threadbuffer,envoiInfo.length(),0,(SOCKADDR *) &to, tosize);
        
        Sleep(20);
    }
    
}

Projectile* Client::getProjectile() {
    return CliProjectile;
}

void Client::setProjectile(Projectile* Pro) {
    CliProjectile = Pro;
}
