/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>

#include "Joueur.h"
#include "Monde.h"
#include "Menu.h"
#include "Texte.h"
#include "Projectile.h"
#include "Message.h"
#include "Jeu.h"

#include <iostream>


Message::Message(Jeu* jeu, int letype, int numJ1, int numJ2) : Listable(), 
gpJeu(jeu), vie(250), x(10), y(50), type(letype), numeroJ1(numJ1), numeroJ2(numJ2) {
    
    if(letype != 0)
    {
        difMsg = new int[jeu->getPartie()->getNbJoueur()];
        for (int i=0;i<jeu->getPartie()->getNbJoueur();i++)
           difMsg[i]=0;
    }
    else
        difMsg = NULL;
    
   s_text = NULL;
}

Message::~Message() {
delete difMsg;
}

void Message::draw(SDL_Surface* gpScreen, int cptMessage) {
    int phg[2];
    phg[0] = gpJeu->getPhg(0);
    phg[1] = gpJeu->getPhg(1);
    
    TTF_Font* p_font = NULL;
       
    SDL_Rect rect_dest;
    SDL_Color color = {255,255,0};
    
    if(TTF_Init () < 0) cerr << "erreur font";
    p_font = TTF_OpenFont ("data/fonts/visitor1.ttf", 10);
    s_text = TTF_RenderText_Solid (p_font, (/*gpJeu->fct.int2string(getListId())+"-"+*/getValueType()).c_str()/*+getNomName().c_str()*/, color);
    
    rect_dest.x = x;
    rect_dest.y = y + (10*cptMessage);
    
    if(vie > 0) vie--;
    if(vie < 50) rect_dest.x -= (150 - (vie*3));
    if(vie > 200) rect_dest.x -= (150 - ((250 - vie)*3));
    
    
    rect_dest.w = s_text->w;
    rect_dest.h = s_text->h;

    if(cptMessage != 0) SDL_BlitSurface (s_text, NULL, gpScreen, & rect_dest);
    TTF_CloseFont (p_font);
    
    if (suivant != NULL) 
        if (((Message*)suivant)->vie == 0) enleve(suivant);
    if (suivant != NULL) ((Message*)suivant)->draw(gpScreen, cptMessage+1);
}

int Message::getX() {return x;}
int Message::getY() {return y;}
int Message::getVie() {return vie;}

string Message::getValueType()
{
    string chaine;
    switch(type) {
      case 0 : chaine = "Erreur"; break;           
      case 1 : chaine = "Probleme TCP"; break;
      case 2 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " vient de se connecter"; break;
      case 3 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " a tu " + gpJeu->getAutreJoueur(numeroJ2)->getNomName(); break;
      case 4 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " a vol " + gpJeu->getAutreJoueur(numeroJ2)->getNomName(); break;
      case 5 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " devient le fantome"; break;
      case 6 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " a quitt la partie"; break;
      case 7 : chaine = "Probleme UDP"; break;
      case 8 : chaine = gpJeu->getAutreJoueur(numeroJ1)->getNomName() + " dommine la partie"; break;
    }
    return chaine;
}

string Message::listServeur(int numJ, int TroisMsg, int cptMessage)
{
    std::ostringstream i;
    string i2;
    if (type != 0)
       if(difMsg[numJ]==0)
        {
            i<< type ;
            i<< "!";
            i<< numeroJ1;
            i<< "!";
            i<< numeroJ2;
            i<< "!";
            i2 = i.str();
            
            difMsg[numJ]=1;
            TroisMsg++;
        }

    cptMessage++;
    
    if (suivant != NULL && TroisMsg < 3) i2 += ((Message*)suivant)->listServeur(numJ,TroisMsg, cptMessage);  
    if (suivant == NULL && TroisMsg < 3) 
        for (int j=TroisMsg; j<3; j++)
            i2 += "0!0!0!";
    
    return i2;             
}

Message* Message::getSuivant() {
    return (Message*)suivant;
}
