/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Origine des sources :
    Zelda Return of the Hylian
    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __PROJECTILE_H__
#define __PROJECTILE_H__

#include "Listable.h"
#include "Common.h"

class Jeu;

class Projectile : public Listable {
    public :
        Projectile(Jeu* jeu, int type, Direction dir, int a, int b, int vit);
        Projectile(Jeu* jeu, int type, Direction dir, int a, int b, int vit, int letireur);
        ~Projectile();
        void draw(SDL_Surface* gpScreen);
        void drawPrClient(SDL_Surface* gpScreen);
        /*int getX();
        int getY();
        void setX(int i);
        void setY(int i);
        void setDirection(Direction d);
        Direction getDirection();*/
        string listServeur();
        int cptServeur();
        int getAnim();
        void setAnim(int i);
        int getTireur();
        void tueJoueurFleche(int numCible);
        //void listClient(std::ostringstream envoi);
        
    private :
        void move(int dx, int dy);
        void attaque();
        void dessinChaine(SDL_Surface* gpScreen);
        void dessinTrainee(SDL_Surface* gpScreen);
        void testAgrippe();
        void changeType(int type);
        void fin();
        
        Jeu* gpJeu;
        int tireur;
        int id;
        Direction direction;
        int x;
        int y;
        int anim;
        int max;
        int vanim;
        int vie;
        int hauteur;
        int vitesse;
        SDL_Surface* image;
        int etape; //pour les objets revenant
        int chemin; //chemin parcourru
        int chmax; //chemin max
        int w;
        int h;
        int zx; //zone de la flche
        int zy;
        int zw;
        int zh;
        Uint32 lastAnimTime;
};

#endif  // Projectile.h
