/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include "Serveur.h"
#include "Projectile.h"
#include "Statut.h"
#include "Joueur.h"
#include "Monde.h"
#include "Menu.h"
#include "Texte.h"
#include "Jeu.h"

#define _MAX_HOST_LENGTH_ 100
#define PORTTCP 23734
#define PORTUDP 23735


Serveur::Serveur(Jeu* jeu): gpJeu(jeu) {
//	port	= 7001;
	running	= false;
}

int Serveur::init(){
	//info joueur serveur
	int i;
    nbrCli = 0;
    nombreDeJoueur = 0;
	listeCli = new adrClient[gpJeu->getPartie()->getNbJoueur()];
    for(i=0; i<gpJeu->getPartie()->getNbJoueur(); i++ ) listeCli[i].actifCli=false;
    for(i=0; i<gpJeu->getPartie()->getNbJoueur(); i++ ) listeCli[i].okUdpCli=false;
    aToucheServeur = new bool[gpJeu->getPartie()->getNbJoueur()];
    for(i=0; i<=gpJeu->getPartie()->getNbJoueur(); i++) aToucheServeur[i] = false;
    aTireServeur = false;
    ServProjectile = new Projectile(gpJeu, 0, N, 0, 0, 0);
    
    listeCli[0].actifCli = true;//serveur
    listeCli[0].okUdpCli = true;//serveur aussi
    
    struct in_addr  MyAddress;
	struct hostent  *host;
	char HostName[_MAX_HOST_LENGTH_];
	WSADATA	      wsaData;
    
    if(WSAStartup(MAKEWORD(2,2), &wsaData ) != 0 ){
		cerr <<"WSAStartup a chou "<< endl;
		return 1;
	}

	if( gethostname( HostName, _MAX_HOST_LENGTH_ ) == SOCKET_ERROR ){
		cerr<< "gethostname() a rencontr l'erreur "<< WSAGetLastError()  << endl;
		return 1;
	}

	if( (host = gethostbyname( HostName ) ) == NULL){
		cerr <<"gethostbyname() a rencontr l'erreur "<< WSAGetLastError()<< endl;
		return 1;
	}

	memcpy( &MyAddress.s_addr, host->h_addr_list[0], sizeof( MyAddress.s_addr ) );

	ServerAddr.sin_family = AF_INET;
	ServerAddr.sin_port = htons( gpJeu->getPortTCP() );
	ServerAddr.sin_addr.s_addr = inet_addr( inet_ntoa( MyAddress ) );

	cout <<"server correctement initialise sur " << inet_ntoa(MyAddress) <<  endl;
	
	
    //creation du socket UDP
    sockUDP = socket (AF_INET, SOCK_DGRAM, 0);
    if(sockUDP == INVALID_SOCKET)
    {
          //gpJeu->setMessage(7);
          return 1;
    }
    
	sin.sin_addr.s_addr = htonl(INADDR_ANY);
    sin.sin_family = AF_INET;
    sin.sin_port = htons(gpJeu->getPortUDP());
    
    if(bind(sockUDP, (SOCKADDR *) &sin, sizeof sin) == SOCKET_ERROR)
    {
          //gpJeu->setMessage(7);
          return 1;
    }
    //fin creation socket UDP
    
    //lance le thread TCP
	HANDLE hProcessThread;
	hProcessThread = CreateThread(NULL, 0,&Serveur::ThreadLauncherStart, this,0,NULL);
	
	//lance le thread UDP ecoute
    HANDLE hProcessThreadUDPec;
  	hProcessThreadUDPec = CreateThread(NULL, 0,&Serveur::ThreadLauncherStartUDP, this,0,NULL);
	
    //lance le thread UDP envoi
    HANDLE hProcessThreadUDPen;
  	hProcessThreadUDPen = CreateThread(NULL, 0,&Serveur::ThreadLauncherStart2UDP, this,0,NULL);
			
	return 0;
}

Projectile* Serveur::getProjectile() {
    return ServProjectile;
}

void Serveur::setProjectile(Projectile* Pro) {
    ServProjectile = Pro;
}

DWORD Serveur::start (){
	SOCKADDR_IN                 ClientAddr;
	int                         ClientAddrLen;
	HANDLE                      hProcessThread;
	SOCKET                      NewConnection;
	struct thread_param         p;
    

	if( ( ListeningSocket = socket( PF_INET, SOCK_STREAM, 0 ) ) == INVALID_SOCKET ){
		cerr << "Le serveur ne peut crer la socket. Erreur n " << WSAGetLastError()<< endl;
		WSACleanup();
		return 1;
	}

	if( bind( ListeningSocket, (SOCKADDR *)&ServerAddr, sizeof( ServerAddr ) ) == SOCKET_ERROR ){
		cerr << "bind a chou avec l'erreur " << WSAGetLastError() << endl;
		cerr << "Le port est peut-tre dj utilis par un autre processus " << endl;
		closesocket( ListeningSocket );
		WSACleanup();
		return 1;
	}

	if( listen( ListeningSocket, 5 ) == SOCKET_ERROR ){
		cerr << "listen a chou avec l'erreur " << WSAGetLastError() << endl;
		closesocket( ListeningSocket );
		WSACleanup();
		return 1;
	}

	//cout << "Serveur demarre : a l'ecoute du port " << port << endl;
	stopRunning = false;
	ClientAddrLen = sizeof( ClientAddr );

	while(!stopRunning){

		if((NewConnection = accept( ListeningSocket, (SOCKADDR *) &ClientAddr, &ClientAddrLen)) == INVALID_SOCKET){
			cerr  << "accept a echoue avec l'erreur " << WSAGetLastError() << endl;;
			closesocket( ListeningSocket );
			WSACleanup();
			return 1;
		}

		p.ser = this;
		p.soc = NewConnection;

		//cout << "client connecte ::  IP : " <<inet_ntoa( ClientAddr.sin_addr )<< " ,port = " <<ntohs( ClientAddr.sin_port ) << endl;

		hProcessThread = CreateThread(NULL, 0,&Serveur::ThreadLauncher, &p,0,NULL);
		if ( hProcessThread == NULL ){
			cerr << "CreateThread a echoue avec l'erreur " <<GetLastError()<< endl;
		}
        
        while(nombreDeJoueur>=10)
        {
           Sleep(50);                      
        }
        	
	}

    closesocket( ListeningSocket );

	return 0;
}

int Serveur::pause (){
	running = false;
	cout << "Serveur en pause" << endl;
	closesocket( ListeningSocket );
	return 0;
}

DWORD Serveur::EcouteUDP (){
    
    int i, j;
    
    int tailleBuffer = 800;
	std::ostringstream oss;
    std::istringstream issBuf;
	char* buffer;
	char** infoRecu = new char*[100];
    //string recu;
    int err = 0;
	buffer = new char[tailleBuffer];
    string envoiInfo;
	char *stptr;
	int lire;
    
    bool aTire[gpJeu->getPartie()->getNbJoueur()];
    for(i=0; i<=gpJeu->getPartie()->getNbJoueur(); i++)
          aTire[i] = false;
    
    bool aTouche[gpJeu->getPartie()->getNbJoueur()][gpJeu->getPartie()->getNbJoueur()];
    for(i=0; i<=gpJeu->getPartie()->getNbJoueur(); i++)
       for(j=0; j<=gpJeu->getPartie()->getNbJoueur(); j++)
          aTouche[i][j] = false;
    
    //test socket
    SOCKADDR_IN  from = { 0 };
	int fromsize = sizeof(from);
    
    stopEcouteUDP = false;
    
          
    while (!stopEcouteUDP)
    {
      
      err=recvfrom(sockUDP,buffer,tailleBuffer,0,(SOCKADDR *) &from, &fromsize);
      lire = 0;
      
        //recu = issBuf.str();
        stptr = strtok (buffer,"!");
         
        while (stptr != NULL)
        {
         
            infoRecu[lire]=stptr;
            lire++;
            stptr = strtok (NULL, "!");
    
        }
  	    //gpJeu->setMessage(issBuf.str());
  	    existeClient(atoi(infoRecu[0]), &from);
       
        gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setX(atoi(infoRecu[1]));
        gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setY(atoi(infoRecu[2]));
    	gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setDirection(gpJeu->int2Dir(atoi(infoRecu[3])));
    	if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getTypeAnim()!=atoi(infoRecu[4]))
    	    gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setTypeAnim(atoi(infoRecu[4]));
    	
      //traite info
      
        if(atoi(infoRecu[4])!=EPEE)
    	   for(i=0; i<=nombreDeJoueur; i++) aTouche[atoi(infoRecu[0])][i] = false;
        
        //coup d'pe
        if(atoi(infoRecu[4])==EPEE)
    	  for(i=0; i<=nombreDeJoueur; i++)
            if(i!=atoi(infoRecu[0]) && gpJeu->getAutreJoueur(i)->getTypeAnim()!= TOUCHE && !aTouche[atoi(infoRecu[0])][i]  && gpJeu->getAutreJoueur(i)->getVie() >0 )
              if(gpJeu->tueJoueur(atoi(infoRecu[1]), atoi(infoRecu[2]), atoi(infoRecu[4]), i, gpJeu->int2Dir(atoi(infoRecu[3]))))
              {
                   aTouche[atoi(infoRecu[0])][i] = true;
                   gpJeu->getPartie()->Contact(atoi(infoRecu[0]), i, 1);
             }
     
    	     
        //gestion tire projectile
        if(atoi(infoRecu[4])!=ARC && atoi(infoRecu[4])!=BFEU) aTire[atoi(infoRecu[0])] = false;
                  
        if(atoi(infoRecu[4])==ARC && !aTire[atoi(infoRecu[0])] && ServProjectile->cptServeur() < 10)
        {
           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->tireFleche(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getNumero());
           aTire[atoi(infoRecu[0])] = true;
        }
             
    	if((atoi(infoRecu[4])==BFEU) && !aTire[atoi(infoRecu[0])] && ServProjectile->cptServeur() < 10)
        {
           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->tireMagie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getNumero());
           aTire[atoi(infoRecu[0])] = true;
        }
        
        //gestion chute
        if(atoi(infoRecu[4])==CHUTE)
        {
           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setVie(1);
        }
    }

    //closesocket(sockUDP);
	
}

DWORD Serveur::EnvoiUDP (){
    
    int i;
    
    int tailleBufferEnvoi = 800;
	std::ostringstream oss;
    std::istringstream issBuf;
	char* bufferEnvoi;
	int err = 0;
	bufferEnvoi = new char[tailleBufferEnvoi];
    string envoiInfo;
	
    stopEnvoiUDP = false;
        
    while (!stopEnvoiUDP)
    {
        if (nombreDeJoueur>0)
        {
            for (i = 0; i < tailleBufferEnvoi; i++) bufferEnvoi[i] = ' ';
    	  
            oss.str("");
            oss << nombreDeJoueur;
            oss << "!";
                    
            for(i=0; i<=nombreDeJoueur; i++)
            {     
                   oss << gpJeu->getAutreJoueur(i)->getNumero();
                   oss << "!";
                   oss << gpJeu->getAutreJoueur(i)->getX();
                   oss << "!";
                   oss << gpJeu->getAutreJoueur(i)->getY();
                   oss << "!";
                   oss << gpJeu->dir2Int(gpJeu->getAutreJoueur(i)->getDirection());
                   oss << "!";
                   oss << gpJeu->getAutreJoueur(i)->getTypeAnim();
                   oss << "!";
            }
            
            oss << ServProjectile->cptServeur();
            oss << "!";
            oss << ServProjectile->listServeur();
        	
        	//on envoi a tous le monde
        	envoiInfo = oss.str();
            for (i = 0; i < tailleBufferEnvoi; i++) bufferEnvoi[i] = ' ';
        	for (i = 0; i < envoiInfo.length(); i++) bufferEnvoi[i] = envoiInfo[i];
    	
            for(i = 0; i < gpJeu->getPartie()->getNbJoueur(); i++)
            {
               if(listeCli[i].actifCli && listeCli[i].okUdpCli)
                  err=sendto(sockUDP,bufferEnvoi,envoiInfo.length(),0,(SOCKADDR *) &listeCli[i].sinCli, sizeof(listeCli[i].sinCli));
            }
            //cout<<"ServeurEnvoiUDP:"<<envoiInfo<<endl;
        }
          
        Sleep(20);
    }
    //closesocket(sockUDP);
	
}

void Serveur::imitClient(){
     
    int i;
     
    if(gpJeu->getJoueur()->getTypeAnim()!=2)
	   for(i=0; i<=nombreDeJoueur; i++) aToucheServeur[i] = false;
    
    if(gpJeu->getJoueur()->getTypeAnim()==2)
	  for(i=1; i<=nombreDeJoueur; i++)
        if(gpJeu->getAutreJoueur(i)->getTypeAnim()!= TOUCHE && !aToucheServeur[i] && gpJeu->getAutreJoueur(i)->getVie() >0 )
          if(gpJeu->tueJoueur(gpJeu->getJoueur()->getX(), gpJeu->getJoueur()->getY(), gpJeu->getJoueur()->getTypeAnim(), i, gpJeu->getJoueur()->getDirection()))
          {
               aToucheServeur[i] = true;
               gpJeu->getPartie()->Contact(0, i, 1);
          }
    
    //gestion tire projectile
    if(gpJeu->getJoueur()->getTypeAnim()!=5 && gpJeu->getJoueur()->getTypeAnim()!=8 && gpJeu->getJoueur()->getTypeAnim()!=9) aTireServeur = false;
              
    if(gpJeu->getJoueur()->getTypeAnim()==5 && !aTireServeur && ServProjectile->cptServeur() < 10)
    {
       gpJeu->getJoueur()->tireFleche();
       aTireServeur = true;
    }
         
	if((gpJeu->getJoueur()->getTypeAnim()==8 || gpJeu->getJoueur()->getTypeAnim()==9) && !aTireServeur && ServProjectile->cptServeur() < 10)
    {
       gpJeu->getJoueur()->tireMagie();
       aTireServeur = true;
    }  
       
}
     
void Serveur::testProjectile(){
     
    int i;
     
    for(i=0; i<=nombreDeJoueur; i++)
       ServProjectile->tueJoueurFleche(i);
	          
}

DWORD Serveur::ClientThread(SOCKET soc){
	//initialisation du thread
	int a = 0;
	int i;
	int err = 0;
	bool stopClient = false;
    
	
	//pour envoyer
    std::ostringstream oss;
    string envoiInfo="";
	int tailleBuffer = 800;
	char* buffer = new char[tailleBuffer];
    
    //pour recevoir
    int lire;
	char *stptr;
    std::istringstream issBuf;
	char** infoRecu = new char*[100];
    string recu;
    
    //pour ne pas repeter les actions
    bool aTouche[gpJeu->getPartie()->getNbJoueur()];
    for(i=0; i<=gpJeu->getPartie()->getNbJoueur(); i++) aTouche[i] = false;
    bool aTire = false;
    
    //detemie le numero du client
    nombreDeJoueur ++;
    int threadJoueur=1;
    for(i=0; i< gpJeu->getPartie()->getNbJoueur(); i++)
    {
       if(listeCli[threadJoueur].actifCli) {threadJoueur++;}
       else{listeCli[threadJoueur].actifCli=true; break;}
    }
    
    gpJeu->getAutreJoueur(threadJoueur)->visible();
    
    //determine le nombre de joueur en cours
    int joueurEnCours = 0;
    for(i=0; i< gpJeu->getPartie()->getNbJoueur(); i++)
    {
       if(!gpJeu->getAutreJoueur(i)->estInvisible()) 
          joueurEnCours++;
    }
	
    
    //reception pseudo du joueur
    for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
	err=recv(soc,buffer,tailleBuffer,0);
    
    //lecture des premieres informations
    lire = 0;
    stptr = strtok (buffer,"!");
    while (stptr != NULL)
    {
        infoRecu[lire]=stptr;
        lire++;
        stptr = strtok (NULL, "!");
    }
    
    //reception du pseudo
    //stptr = strtok (buffer,"!");
    gpJeu->getAutreJoueur(threadJoueur)->setPseudo(infoRecu[0]);
    //reception du choix du pseudo
    //stptr = strtok (buffer,"!");
    gpJeu->getAutreJoueur(threadJoueur)->setNom(atoi(infoRecu[1]));
    
    
    //envoi des information de la partie
    oss.str(""); 
    oss << threadJoueur;
    oss << "!";
    oss << gpJeu->getPartie()->getArene();
    oss << "!";
    oss << gpJeu->getPartie()->getTypeJeu();
    oss << "!";
    oss << gpJeu->getPartie()->getLimite();
    oss << "!";
    envoiInfo = oss.str();
	for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
	for (i = 0; i < envoiInfo.length(); i++) buffer[i] = envoiInfo[i];
	    err=send(soc,buffer,envoiInfo.length(),0);
    
    gpJeu->setMessage(2,threadJoueur);
    
    while(!stopClient)
	{
                      
        //reception des informations
        for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
    	err=0;
        err=recv(soc,buffer,tailleBuffer,0);
        
        if(err==-1 || buffer[0]=='Q')
         break;
        
        //std::istringstream issBuf(buffer);
        //cout<<"ServeurR:"<<issBuf.str()<<endl;
        
        //lecture des informations
        lire = 0;
        stptr = strtok (buffer,"!");
        while (stptr != NULL)
        {
            infoRecu[lire]=stptr;
            lire++;
            stptr = strtok (NULL, "!");
        }
    
        if(atoi(infoRecu[0]) != 0) // en cas de probleme avec le client
        {    
            if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getCouleur()!=atoi(infoRecu[1]))
            {
                gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setCouleur(atoi(infoRecu[1]));
        	    if(gpJeu->getPartie()->getTypeJeu()== 4) gpJeu->getPartie()->ModifierJoueur(atoi(infoRecu[0]));
            }
            if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getNom()!=atoi(infoRecu[2]))
                gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setNom(atoi(infoRecu[2]));
        	/*if(gpJeu->getAutreJoueur(threadJoueur)->getVie()<=0 && atoi(infoRecu[3])==gpJeu->getAutreJoueur(threadJoueur)->getVieMax())
            	gpJeu->getAutreJoueur(threadJoueur)->setVie(atoi(infoRecu[3]));*/
        	if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getZone()!=atoi(infoRecu[4]))
                gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setZone(atoi(infoRecu[4]));
        	if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getObjet()!=atoi(infoRecu[5]))
        	 {
                //le joueur tient une bouteille
                if (atoi(infoRecu[5])>= 5)
                {
                    //on verifier si c'est la bouteille a changer
                    if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) != atoi(infoRecu[5])-4)
                    {
                        //cas 1 : il a bu une bouteille rouge
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 2 && atoi(infoRecu[5]) == 5 )
                          gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setVie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getVieMax());
                        
                        //cas 2 : il a bu une bouteille vert
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 3 && atoi(infoRecu[5]) == 5 )
                          gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setMagie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getMagieMax());
                        
                        //cas 3 : il a bu une bouteille bleue
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 4 && atoi(infoRecu[5]) == 5 )
                        {
                           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setVie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getVieMax());
                           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setMagie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getMagieMax());
                        }
                        
                        //cas 4 : il a achete une bouteille rouge
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 1 && atoi(infoRecu[5]) == 6 )
                        {
                           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setRubis(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getRubis()-10);
                        }
                        
                        //cas 5 : il a achete une bouteille verte
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 1 && atoi(infoRecu[5]) == 7 )
                        {
                           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setRubis(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getRubis()-8);
                        }
                        
                        //cas 6 : il a achete une bouteille bleue
                        if (gpJeu->getAutreJoueur(atoi(infoRecu[0]))->hasBouteille(0) == 1 && atoi(infoRecu[5]) == 8 )
                        {
                           gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setRubis(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getRubis()-15);
                        }
                        
                        
                        gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setBouteille(0,atoi(infoRecu[5])-4);
                    }
                    gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setObjet(5);
                }
                else
                    gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setObjet(atoi(infoRecu[5]));
             }
        	//gestion revie
        	if(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getVie()==0 && atoi(infoRecu[3])==1)
               gpJeu->getAutreJoueur(atoi(infoRecu[0]))->setVie(gpJeu->getAutreJoueur(atoi(infoRecu[0]))->getVieMax());
         }

        //on recalcul toujours le nombre de joueur en acours
        joueurEnCours = 0;
        for(i=0; i< gpJeu->getPartie()->getNbJoueur(); i++)
        {
           if(!gpJeu->getAutreJoueur(i)->estInvisible()) 
              joueurEnCours++;
        }

        //donnee pour le client
        oss.str(""); 
        //oss << nombreDeJoueur;
        oss << joueurEnCours;
        oss << "!";
        oss << gpJeu->getPartie()->getJeuFini();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getVie();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getScore();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getNumero();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getMagie();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getFleche();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->getRubis();
        oss << "!";
        oss << gpJeu->getAutreJoueur(threadJoueur)->isFantome();
        oss << "!";
        //donner des autres joueurs envoy au cient
        for(i=0; i<gpJeu->getPartie()->getNbJoueur(); i++)
        {
            if(i!=threadJoueur && !gpJeu->getAutreJoueur(i)->estInvisible())
            {
               oss << gpJeu->getAutreJoueur(i)->getNumero();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getCouleur();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getNom();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getPseudo();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getZone();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getScore();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->getObjet();
               oss << "!";
               oss << gpJeu->getAutreJoueur(i)->isFantome();
               oss << "!";
            }
        }
        
        //envoi des messages
        oss << gpJeu->getMessage()->listServeur(threadJoueur,0,0);
        
        //envoi des informations
        envoiInfo = oss.str();
	   // cout<<"ServeurE:"<<envoiInfo<<endl;
	    
        for (i = 0; i < tailleBuffer; i++) buffer[i] = ' ';
    	for (i = 0; i < envoiInfo.length(); i++) buffer[i] = envoiInfo[i];
    	err=send(soc,buffer,envoiInfo.length(),0);
        if(err==-1)
         break;
         
         Sleep(2);
        
    }
    
    listeCli[threadJoueur].actifCli=false;
    listeCli[threadJoueur].okUdpCli=false;
    
    bool finDePartie;
    if (gpJeu->getPartie()->getJeuFini() == 1)
    {
        finDePartie=true;
        for(i = 1; i < gpJeu->getPartie()->getNbJoueur(); i++)
        {
           if(listeCli[i].actifCli)
               finDePartie=false;
        }
            
        if(finDePartie)
        {
      		stopEcouteUDP = true;
		    stopEnvoiUDP = true; 
		    stopRunning = true;
		    closesocket(sockUDP);
		    delete listeCli;
            delete aToucheServeur;
	        delete ServProjectile;
            gpJeu->finDePartie();
            return 0;
        }
    }
    else
    {
        //dconnexion d'un client en cours de partie
        gpJeu->setMessage(6,threadJoueur);
        gpJeu->getAutreJoueur(threadJoueur)->nonVisible();
        gpJeu->getAutreJoueur(threadJoueur)->setScore(0);
        nombreDeJoueur--;
        //A FAIRE
    }

    
    closesocket(soc);
    delete buffer;
    return 0;
    
}

//gestion du catalogue UDP
int Serveur::existeClient(int cnum, SOCKADDR_IN *csin)
{
   if((listeCli[cnum].sinCli.sin_addr.s_addr != csin->sin_addr.s_addr
	    || listeCli[cnum].sinCli.sin_port != csin->sin_port)
	    && listeCli[cnum].actifCli)
	    {
	      listeCli[cnum].sinCli = *csin;
	      listeCli[cnum].okUdpCli = true;
        }
   return 0;
}

int Serveur::getnombreDeJoueur()
{
   return  nombreDeJoueur;
}

Serveur::~Serveur()
{
    
}
