/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#ifndef __SERVEUR_H__
#define __SERVEUR_H__

#include<stdio.h>	
#include<winsock2.h>
#pragma comment(lib,"ws2_32.lib")
#include "Projectile.h"
//#include "UDP.h"

class Jeu;

class Serveur;

struct thread_param{
       Serveur* ser;
       SOCKET soc;
};

struct adrClient
{
   bool actifCli;
   bool okUdpCli;
   SOCKADDR_IN sinCli;
};

class Serveur{
	private: 
		int           port;
		SOCKET	      ListeningSocket;
		SOCKET        sockUDP;
		SOCKADDR_IN   sin;
		bool          running;  
		SOCKADDR_IN   ServerAddr;   
		DWORD         ClientThread(SOCKET);
		DWORD start();
		DWORD EcouteUDP();
		DWORD EnvoiUDP();
		
		int nombreDeJoueur;
		Jeu* gpJeu;
		adrClient* listeCli;
		int nbrCli;
		
		//pour le joueur
		bool* aToucheServeur;
		bool aTireServeur;
		Projectile* ServProjectile;
		
		//pour gere les connexion
		bool stopEcouteUDP;
		bool stopEnvoiUDP;
		bool stopRunning;
		
		int existeClient(int cnum, SOCKADDR_IN *csin);
		
	public:                                        
		Serveur(Jeu* jeu);
		~Serveur();
        int init();
        Projectile* getProjectile();
        void setProjectile(Projectile* Pro);
        
        void imitClient();
        void testProjectile();
        int getnombreDeJoueur();
		int pause ();
			
        static DWORD WINAPI ThreadLauncherStart(void *ser){
			Serveur *s = (Serveur*)ser;                          
			return s->start();       
		}
		
		static DWORD WINAPI ThreadLauncherStartUDP(void *ser){
			Serveur *s = (Serveur*)ser;                          
			return s->EcouteUDP();       
		}
		
		static DWORD WINAPI ThreadLauncherStart2UDP(void *ser){
			Serveur *s = (Serveur*)ser;                          
			return s->EnvoiUDP();       
		}
		
        
        static DWORD WINAPI ThreadLauncher(void *p){
			struct thread_param *Obj = reinterpret_cast<struct thread_param*>(p);               
			Serveur *s = Obj->ser;                          
			return s->ClientThread(Obj->soc);       
		}
}; 


#endif
