/*
    Zelda Battle Of Hyrule
    Copyright (C) 2009  Vincent Bourgogne
    
    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include "Utile.h"
#include <cstdlib>
#include <iostream>

void Utile::echanger(int tab[], int i, int j)
{
     int memoire;
     memoire=tab[i];
     tab[i]=tab[j];
     tab[j]=memoire;
}

int Utile::partition(int tableau[], int deb, int fin)
    {
    int compt=deb;
    int pivot=tableau[deb];
    int i;

    for(i=deb+1;i<=fin;i++)
        {
        if(tableau[i]<pivot)
            {
            compt++;
            echanger(tableau,compt,i);
            }
        }
    echanger(tableau,compt,deb);
    return(compt);
    }

void Utile::tri_rapide_bis(int tableau[],int debut,int fin)
    {
    if(debut<fin)
        {
        int pivot=partition(tableau,debut,fin);
        tri_rapide_bis(tableau,debut,pivot-1);
        tri_rapide_bis(tableau,pivot+1,fin);
        }
    }

void Utile::tri_rapide(int tableau[],int longueur)
     {
     tri_rapide_bis(tableau,0,longueur-1);
     }
     

int Utile::partition2T(int tableau[], int tableau2[], int deb, int fin)
    {
    int compt=deb;
    int pivot=tableau[deb];
    int i;

    for(i=deb+1;i<=fin;i++)
        {
        if(tableau[i]<pivot)
            {
            compt++;
            echanger(tableau,compt,i);
            echanger(tableau2,compt,i);
            }
        }
    echanger(tableau,compt,deb);
    echanger(tableau2,compt,deb);
    
    return(compt);
    }

void Utile::tri_rapide_bis2T(int tableau[],int tableau2[], int debut,int fin)
    {
    if(debut<fin)
        {
        int pivot=partition2T(tableau, tableau2,debut,fin);
        tri_rapide_bis2T(tableau,tableau2,debut,pivot-1);
        tri_rapide_bis2T(tableau,tableau2,pivot+1,fin);
        }
    }

void Utile::tri_rapide2T(int tableau[],int tableau2[], int longueur)
     {
     tri_rapide_bis2T(tableau, tableau2,0,longueur-1);
     }


string Utile::int2string(int a)
{
   std::ostringstream oss;
   oss << a;
   
   string b = oss.str();
       
   return b;    
}

